/*
 * generated by Xtext 2.26.0
 */
package org.eclipse.gef.dot.internal.ide.language.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.gef.dot.internal.ide.language.contentassist.antlr.internal.InternalDotFontNameParser;
import org.eclipse.gef.dot.internal.language.services.DotFontNameGrammarAccess;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class DotFontNameParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(DotFontNameGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, DotFontNameGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getFontNameAccess().getAlternatives(), "rule__FontName__Alternatives");
			builder.put(grammarAccess.getPangoFontNameAccess().getAlternatives(), "rule__PangoFontName__Alternatives");
			builder.put(grammarAccess.getPangoFontNameAccess().getAlternatives_0_0(), "rule__PangoFontName__Alternatives_0_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_0_0_0_1_0(), "rule__PangoFontName__FinalFamilyAlternatives_0_0_0_1_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_0_0_0_2_0(), "rule__PangoFontName__FinalFamilyAlternatives_0_0_0_2_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_0_0_1_0_0(), "rule__PangoFontName__FinalFamilyAlternatives_0_0_1_0_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_0_0_1_1_0(), "rule__PangoFontName__FinalFamilyAlternatives_0_0_1_1_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_0_0_1_2_0(), "rule__PangoFontName__FinalFamilyAlternatives_0_0_1_2_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_1_0_1_0(), "rule__PangoFontName__FinalFamilyAlternatives_1_0_1_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAlternatives_1_0_2_0(), "rule__PangoFontName__FinalFamilyAlternatives_1_0_2_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getAlternatives_1_0_4(), "rule__PangoFontName__Alternatives_1_0_4");
			builder.put(grammarAccess.getPangoFamilyAccess().getAlternatives(), "rule__PangoFamily__Alternatives");
			builder.put(grammarAccess.getStyleOptionsElementAccess().getAlternatives(), "rule__StyleOptionsElement__Alternatives");
			builder.put(grammarAccess.getStyleOptionStringAccess().getAlternatives(), "rule__StyleOptionString__Alternatives");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_0(), "rule__PangoFontName__Group_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_0_0_0(), "rule__PangoFontName__Group_0_0_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_0_0_0_0(), "rule__PangoFontName__Group_0_0_0_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_0_0_1(), "rule__PangoFontName__Group_0_0_1__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_1(), "rule__PangoFontName__Group_1__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_1_0(), "rule__PangoFontName__Group_1_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_1_0_0(), "rule__PangoFontName__Group_1_0_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_2(), "rule__PangoFontName__Group_2__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_2_1(), "rule__PangoFontName__Group_2_1__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_2_1_0(), "rule__PangoFontName__Group_2_1_0__0");
			builder.put(grammarAccess.getPangoFontNameAccess().getGroup_2_1_0_0(), "rule__PangoFontName__Group_2_1_0_0__0");
			builder.put(grammarAccess.getPostScriptFontNameAccess().getAliasAssignment(), "rule__PostScriptFontName__AliasAssignment");
			builder.put(grammarAccess.getPangoFontNameAccess().getFamiliesAssignment_0_0_0_0_0(), "rule__PangoFontName__FamiliesAssignment_0_0_0_0_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_0_1(), "rule__PangoFontName__FinalFamilyAssignment_0_0_0_1");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_0_2(), "rule__PangoFontName__FinalFamilyAssignment_0_0_0_2");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_1_0(), "rule__PangoFontName__FinalFamilyAssignment_0_0_1_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_1_1(), "rule__PangoFontName__FinalFamilyAssignment_0_0_1_1");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_1_2(), "rule__PangoFontName__FinalFamilyAssignment_0_0_1_2");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_0_0_2(), "rule__PangoFontName__FinalFamilyAssignment_0_0_2");
			builder.put(grammarAccess.getPangoFontNameAccess().getFamiliesAssignment_1_0_0_0(), "rule__PangoFontName__FamiliesAssignment_1_0_0_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_1_0_1(), "rule__PangoFontName__FinalFamilyAssignment_1_0_1");
			builder.put(grammarAccess.getPangoFontNameAccess().getFinalFamilyAssignment_1_0_2(), "rule__PangoFontName__FinalFamilyAssignment_1_0_2");
			builder.put(grammarAccess.getPangoFontNameAccess().getStyleOptionsListAssignment_1_0_3(), "rule__PangoFontName__StyleOptionsListAssignment_1_0_3");
			builder.put(grammarAccess.getPangoFontNameAccess().getStyleOptionsListAssignment_1_0_4_0(), "rule__PangoFontName__StyleOptionsListAssignment_1_0_4_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getFamiliesAssignment_2_1_0_0_0(), "rule__PangoFontName__FamiliesAssignment_2_1_0_0_0");
			builder.put(grammarAccess.getPangoFontNameAccess().getStyleOptionsListAssignment_2_1_0_1(), "rule__PangoFontName__StyleOptionsListAssignment_2_1_0_1");
			builder.put(grammarAccess.getStyleOptionAccess().getStyleAssignment(), "rule__StyleOption__StyleAssignment");
			builder.put(grammarAccess.getVariantOptionAccess().getVariantAssignment(), "rule__VariantOption__VariantAssignment");
			builder.put(grammarAccess.getWeightOptionAccess().getWeightAssignment(), "rule__WeightOption__WeightAssignment");
			builder.put(grammarAccess.getStretchOptionAccess().getStretchAssignment(), "rule__StretchOption__StretchAssignment");
			builder.put(grammarAccess.getGravityOptionAccess().getGravityAssignment(), "rule__GravityOption__GravityAssignment");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private DotFontNameGrammarAccess grammarAccess;

	@Override
	protected InternalDotFontNameParser createParser() {
		InternalDotFontNameParser result = new InternalDotFontNameParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_OTHER_WS", "RULE_SPACE" };
	}

	public DotFontNameGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(DotFontNameGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
